#include "stdafx.h"
#include "bitaccess.h"
#include "debug.h"
#include "bitcontroller.h"

#define DEBUG while (0) debug

BitController::BitController(DWORD valueport, DWORD directionport, DWORD mask)
{
	m_valueport= valueport;
	m_directionport= directionport;
	m_interestingbits= mask;
}

inline RECT MakeRECT(int x, int y, int w, int h)
{
	RECT r;
	r.left= x;
	r.top= y;
	r.bottom= y+h;
	r.right= x+w;
	DEBUG("converted (%d,%d)x(%d,%d) to (%d,%d) .. (%d,%d)\n",
		x,y,w,h, r.left, r.top, r.right, r.bottom);
	return r;
}

void BitController::MakeBit(int id, int xpos, int ypos, int width, int height, CWnd* parent)
{
	// Create wants the xpos,ypos relative to the parent window
	// GetWindowRect returns the absolute x,y pos

	if (!m_bit[id].Create(MakeRECT(xpos, ypos, width, height), parent, id, TestBitsAny(m_interestingbits, 1<<id)))
		error("error creating button\n");

	m_bit[id].SetController(this);

}
void BitController::CreateControl(CWnd* parent, int xpos, int ypos)
{
	for(int i=0 ; i<32 ; i++)
	{
		MakeBit(31-i, xpos+i*(BIT_WIDTH+1)+i/8, ypos, BIT_WIDTH, BIT_HEIGHT, parent);
	}
}


void BitController::UpdateValues()
{
	DWORD direction= GetMemory(m_directionport)&m_interestingbits;
	DWORD value= GetMemory(m_valueport)&m_interestingbits;
	for (int i=0 ; i<32 ; i++)
	{
		m_bit[i].SetOutput(TestBitsAny(direction, 1<<i));
		m_bit[i].SetValue(TestBitsAny(value, 1<<i));
	}
}
void BitController::SetOutput(int bit, bool bOutput)
{
	if (bOutput)
		SetMemoryBits(m_directionport, 1<<bit);
	else
		ClearMemoryBits(m_directionport, 1<<bit);
}


void BitController::SetValue(int bit, bool bValue)
{
	if (bValue)
		SetMemoryBits(m_valueport, 1<<bit);
	else
		ClearMemoryBits(m_valueport, 1<<bit);
}
