#ifndef __BITCONTROLLER_H__

#include "bitbutton.h"

#define SCREEN_WIDTH 240
#define BIT_WIDTH (SCREEN_WIDTH-32)/32
#define BIT_HEIGHT BIT_WIDTH

class BitController {
public:
	BitController(DWORD valueport, DWORD directionport, DWORD mask);
	~BitController();

	void CreateControl(CWnd *parent, int xpos, int ypos);
	void MakeBit(int id, int xpos, int ypos, int width, int height, CWnd* parent);

	void SetOutput(int bit, bool bOutput);
	void SetValue(int bit, bool bValue);
	void UpdateValues();

private:
	DWORD m_valueport;
	DWORD m_directionport;
	DWORD m_interestingbits;

	CBitButton m_bit[32];
};

#define __BITCONTROLLER_H__
#endif
