// tstmodemDlg.cpp : implementation file
//

// todo:
//		- state needs to be visible with checked menu entries.
//		- output window needs to be better formatted
//		- input edit should always get the focus.
//		- comioctl check needs to be reset when changing ports.

#include "stdafx.h"
#include "tstmodem.h"
#include "tstmodemDlg.h"
#include "bitbutton.h"

#include "serialport.h"
#include "RILState.h"
#include "serialparams.h"
#include "bitcontroller.h"

#include "debug.h"
#include "stringutils.h"

#include "DialogChosePort.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTstmodemDlg dialog

CTstmodemDlg::CTstmodemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTstmodemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTstmodemDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32

	m_ril= NULL;
}

void CTstmodemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTstmodemDlg)
	DDX_Control(pDX, IDC_CHECK_RTSCTS_FLOWCTL, m_cCheckRtsCtsFlowControl);
	DDX_Control(pDX, IDC_STATUS_XMIT, m_cStatusTransmit);
	DDX_Control(pDX, IDC_STATUS_RCV, m_cStatusReceive);
	DDX_Control(pDX, IDC_COUNTER_XMIT, m_cCounterTransmit);
	DDX_Control(pDX, IDC_COUNTER_RLSD, m_cCounterRLSD);
	DDX_Control(pDX, IDC_COUNTER_RING, m_cCounterRing);
	DDX_Control(pDX, IDC_COUNTER_RCV, m_cCounterReceive);
	DDX_Control(pDX, IDC_COUNTER_DSR, m_cCounterDSR);
	DDX_Control(pDX, IDC_COUNTER_CTS, m_cCounterCTS);
	DDX_Control(pDX, IDC_RECEIVE_DATA, m_cListReceiveData);
	DDX_Control(pDX, IDC_CHECK_IR, m_cCheckIR);
	DDX_Control(pDX, IDC_TRANSMIT_DATA, m_cEditTransmitData);
	DDX_Control(pDX, IDC_HEX_DATA, m_cCheckHexData);
	DDX_Control(pDX, IDC_STATUS_RLSD, m_cStatusRLSD);
	DDX_Control(pDX, IDC_STATUS_RING, m_cStatusRing);
	DDX_Control(pDX, IDC_STATUS_BRK, m_cStatusBreak);
	DDX_Control(pDX, IDC_STATUS_DSR, m_cStatusDSR);
	DDX_Control(pDX, IDC_STATUS_CTS, m_cStatusCTS);
	DDX_Control(pDX, IDC_CHECK_RTS, m_cCheckRTS);
	DDX_Control(pDX, IDC_CHECK_DTR, m_cCheckDTR);
	DDX_Control(pDX, IDC_CHECK_BRK, m_cCheckBreak);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_CHECK_VOICE_PATH, m_EnableGsmVoice);
	DDX_Control(pDX, IDC_CHECK_CTRLZ, m_AppendCTRLZ);
}

BEGIN_MESSAGE_MAP(CTstmodemDlg, CDialog)
	//{{AFX_MSG_MAP(CTstmodemDlg)
	ON_BN_CLICKED(IDC_CHECK_DTR, OnCheckDtr)
	ON_BN_CLICKED(IDC_CHECK_RTS, OnCheckRts)
	ON_BN_CLICKED(IDC_CHECK_BRK, OnCheckBrk)
	ON_BN_CLICKED(IDC_BUTTON_TRANSMIT, OnButtonTransmit)
	ON_BN_CLICKED(IDC_CHECK_IR, OnCheckIr)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_RTSCTS_FLOWCTL, OnCheckRtsctsFlowctl)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_RECEIVEDATA, OnReceiveData)
	ON_COMMAND_RANGE(IDM_MENU_SPEED1, IDM_MENU_SPEED49, OnSpeedMenu)
	ON_COMMAND_RANGE(IDM_MENU_PORT1, IDM_MENU_PORT49, OnPortMenu)
	ON_BN_CLICKED(IDC_BUTTON_CONFIG, &CTstmodemDlg::OnBnClickedButtonConfig)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_PORT, &CTstmodemDlg::OnBnClickedButtonOpenPort)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_PORT, &CTstmodemDlg::OnBnClickedButtonClosePort)
	ON_BN_CLICKED(IDC_CHECK_VOICE_PATH, &CTstmodemDlg::OnBnClickedCheckVoicePath)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTstmodemDlg message handlers
void SetCheckbox(CButton& checkbox, int value)
{
	checkbox.SetCheck(value ? BST_CHECKED : BST_UNCHECKED);
}

/////////////////////////////////////////////////////////////
// dynamically creating the menu bar
void AddMenuToCommandBar(CCeCommandBar &cmdbar, TCHAR *name, int menuid, CMenu *popup);
CMenu *MakeMenu(int menuid, CStringArray *itemlist);

void CTstmodemDlg::InitializeMenu()
{
	//m_wndCommandBar.m_bShowSharedNewButton = TRUE;

	if(!m_wndCommandBar.Create(this))
		//|| !m_wndCommandBar.InsertMenuBar(IDR_MENUBAR1))
	{
		error("creating menu");
		return;
	}
	AddMenuToCommandBar(m_wndCommandBar, L"port", IDR_MENU_PORT, MakeMenu(IDR_MENU_PORT+1, SerialParams::GetDeviceList()));
	AddMenuToCommandBar(m_wndCommandBar, L"speed", IDR_MENU_SPEED, MakeMenu(IDR_MENU_SPEED+1, SerialParams::GetSpeedList()));

	::DrawMenuBar(GetSafeHwnd());


}
void AddMenuToCommandBar(CCeCommandBar &cmdbar, TCHAR *name, int menuid, CMenu *popup)
{
	// from http://www.pocketpccode.com/forum/read.php?TID=469
	CToolBarCtrl &pToolbar = cmdbar.GetToolBarCtrl();

	TBBUTTON tbb0;
	tbb0.iBitmap = I_IMAGENONE;
	tbb0.fsState = TBSTATE_ENABLED;
#define TBSTYLE_NO_DROPDOWN_ARROW 0x0080
	tbb0.fsStyle = TBSTYLE_DROPDOWN|TBSTYLE_AUTOSIZE|TBSTYLE_NO_DROPDOWN_ARROW;
	tbb0.dwData = (UINT)popup->m_hMenu;
	tbb0.iString = (UINT)name; // Unicode String
	tbb0.idCommand = menuid; // unique

	pToolbar.InsertButton(pToolbar.GetButtonCount(),&tbb0);

}

CMenu *MakeMenu(int menuid, CStringArray *itemlist)
{
	if (itemlist==NULL) {
		debug("ERROR: no items for menu %d\r\n", menuid);
		return NULL;
	}

	CMenu *pMenu = new CMenu();
	pMenu->CreatePopupMenu(); 

	for(int i=0 ; i < itemlist->GetSize() ; i++)
	{
		if (!pMenu->AppendMenu(MF_STRING|MF_ENABLED, menuid+i, itemlist->GetAt(i)))
			debug("failed to add menuentry\r\n");
	}
	delete itemlist;

	//pMenu->CheckMenuRadioItem(menuid, menuid+i, 0, MF_BYCOMMAND);

	return pMenu;
}


/////////////////////////////////////////////////////////////////
// init dialog
BOOL CTstmodemDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//SetCheckbox(m_cCheckRtsCtsFlowControl, true);

	DebugRegisterWindow(this);

	//SetTimer(1, 200, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CTstmodemDlg::SetModels(SerialPort& port, RILState& ril)
{
	m_port= &port;
	m_ril= &ril;
}

void CTstmodemDlg::OnCheckDtr() 
{
	m_port->SetDTR(m_cCheckDTR.GetCheck()==BST_CHECKED);
}

void CTstmodemDlg::OnCheckRts() 
{
	m_port->SetRTS(m_cCheckRTS.GetCheck()==BST_CHECKED);
}

void CTstmodemDlg::OnCheckBrk() 
{
	m_port->SetBreak(m_cCheckBreak.GetCheck()==BST_CHECKED);
}

void CTstmodemDlg::OnCheckRtsctsFlowctl() 
{
	m_port->SetRtsCtsFlowControl(m_cCheckRtsCtsFlowControl.GetCheck()==BST_CHECKED);
}

void CTstmodemDlg::OnCheckIr() 
{
	m_port->SetIRMode(m_cCheckIR.GetCheck()==BST_CHECKED);
}
void CTstmodemDlg::appendString(const TCHAR *tstr)
{
//	m_cListReceiveData.AddString(str);

	std::string str= ToString(tstr);

	StringList slist;

	// first split string in lines
	size_t ppos= 0;
	while (ppos < str.length()) {
		size_t spos= str.find_first_of("\r\n\x02", ppos);
		if (spos==str.npos)
			break;
		size_t send= str.find_first_not_of("\r\n\x02", spos);
		if (send==str.npos)
			send= str.length();

		slist.push_back(str.substr(ppos, send-ppos));

		ppos= send;
	}
	if (ppos < str.length()) {
		slist.push_back(str.substr(ppos));
	}

	size_t istring= 0;

	// then optionally extend the last unended line
/*
	int last= m_cListReceiveData.GetCount()-1;
	int caret= m_cListReceiveData.GetCurSel();
	if (last>=0 && istring<slist.size()) {
		CString cur;
		m_cListReceiveData.GetText(last, cur);

		int eolpos=cur.FindOneOf(L"\r\n\x02");
		if (eolpos==-1) {
			cur += slist[istring++].c_str();
			m_cListReceiveData.DeleteString(last);
			m_cListReceiveData.InsertString(last, cur);
		}
	}
*/
	// and add the other lines
	while (istring<slist.size()){	
		CString str1 = ToTString(slist[istring++]).c_str();
		CString str2 = str1.Left(str1.FindOneOf(L"\r\n\x02"));
		m_cListReceiveData.AddString(str2);
	}

	//if (last==caret) {
	if (1) {
		int newlast= m_cListReceiveData.GetCount()-1;
		//debug("listbox: last=%d caret=%d -> setting to %d\r\n", last, caret, newlast);
		int rc= m_cListReceiveData.SetCurSel(newlast);
	}


}
LRESULT CTstmodemDlg::OnReceiveData(WPARAM wParam, LPARAM lParam)
{
	CString str;
	m_port->ReceiveData(str);

	appendString(str);

	// todo: add config flag to enable/disable logging
	FILE *f= fopen("\\com.log", "a+");
	if (f)
	{
		fprintf(f, "%ls", str.GetBuffer(0));
		fclose(f);
	}

	return 0;
}

void SetState(CButton& button, CStatic& counter, bool state)
{
	bool oldstate= (button.GetState()==BST_PUSHED);
	//debug("old=%d new=%d  state=%d check=%d\r\n", oldstate, state, button.GetState(), button.GetCheck());
	if (state!=oldstate)
	{
		button.SetState(state);

		CString str;
		counter.GetWindowText(str);
		DWORD nr= _tcstoul(str.GetBuffer(0), 0, 0);
		str.Format(L"%d", nr+1);
		counter.SetWindowText(str);
	}
}
void MySetEvent(CButton& button, CStatic& counter)
{
	bool state= button.GetState()==BST_PUSHED;
	button.SetState(!state);

	CString str;
	counter.GetWindowText(str);
	DWORD nr= _tcstoul(str.GetBuffer(0), 0, 0);
	str.Format(L"%d", nr+1);
	counter.SetWindowText(str);
}
void CTstmodemDlg::CommEventBreak(bool state)
{
	SetState(m_cStatusBreak, m_cCounterBreak, state);
}
void CTstmodemDlg::CommEventCTS(bool state)
{
	SetState(m_cStatusCTS, m_cCounterCTS, state);
}
void CTstmodemDlg::CommEventRing(bool state)
{
	SetState(m_cStatusRing, m_cCounterRing, state);
}
void CTstmodemDlg::CommEventRLSD(bool state)
{
	SetState(m_cStatusRLSD, m_cCounterRLSD, state);
}
void CTstmodemDlg::CommEventDSR(bool state)
{
	SetState(m_cStatusDSR, m_cCounterDSR, state);
}
void CTstmodemDlg::CommEventReceive()
{
	MySetEvent(m_cStatusReceive, m_cCounterReceive);
}
void CTstmodemDlg::CommEventTransmit()
{
	MySetEvent(m_cStatusTransmit, m_cCounterTransmit);
}
void CTstmodemDlg::CommEventInputOverFlow()
{
//	SetState(m_cStatusRcvOverflow, m_cCounterRcvOverflow, state);
}
void CTstmodemDlg::CommEventOutputOverFlow()
{
//	SetState(m_cStatusXmitOverflow, m_cCounterXmitOverflow, state);
}

bool toNyble(char c, int& nyble)
{
	if (c>='0' && c<='9')
	{
		nyble= c-'0';
		return true;
	}
	if (c>='A' && c<='F')
	{
		nyble= c-'A'+10;
		return true;
	}
	if (c>='a' && c<='f')
	{
		nyble= c-'a'+10;
		return true;
	}
	return false;
		
}
void ConvertHexToBytes(CString& str, CString& newstr)
{
	int buflen= str.GetLength()/2;
	TCHAR *buf= newstr.GetBuffer(buflen+1);
	int bi=0;
	int ni=1;	// nyble index ( 1=high, 0=low )

	int strlen= str.GetLength();
	TCHAR *strbuf= str.GetBuffer(0);
	int si=0;

	while (si<strlen)
	{
		char c= (char)strbuf[si++];
		int nyble;
		if (toNyble(c, nyble))
		{
			if (ni)
				buf[bi]= nyble<<4;
			else
				buf[bi++] |= nyble;
			ni= 1-ni;
		}
	}
	newstr.ReleaseBuffer(bi);
}
void CTstmodemDlg::OnButtonTransmit() 
{
	CString str;
	m_cEditTransmitData.GetWindowText(str);

	if (m_cCheckHexData.GetCheck()==BST_CHECKED)
	{
		CString hex= str;
		ConvertHexToBytes(hex, str);
	}
	else
	{
		if (m_AppendCTRLZ.GetCheck() == BST_CHECKED)
		{
			str += (TCHAR)0x1a; //CTRL Z value
		}
		str += "\r";
	}

	m_port->SendData(str);
}

void CTstmodemDlg::OnClose() 
{
	DebugRegisterWindow(NULL);

	CDialog::OnClose();
}

//////////////////////////////////////////////////////////////////////////
//  menu handlers
void FindMenuString(CCeCommandBar *cmdbar, UINT menuentryid, CString &str);


void CTstmodemDlg::OnSpeedMenu(UINT nId) 
{
	//debug("app.speed %d\r\n", nId);
	CString str;
	FindMenuString(&m_wndCommandBar, nId, str);
	m_port->SetSpeed(str);
}
void CTstmodemDlg::OnBitsMenu(UINT nId)
{
	//debug("bits %d\r\n", nId);
	CString str;
	FindMenuString(&m_wndCommandBar, nId, str);
	m_port->SetBits(str);
}
void CTstmodemDlg::OnPortMenu(UINT nId)
{
	//debug("port %d\r\n", nId);
	CString str;
	FindMenuString(&m_wndCommandBar, nId, str);
	m_port->SetPort(str);

	// reset userinterface items
	//SetCheckbox(m_cCheckOpenDevice, false);
}

void FindMenuString(CCeCommandBar *cmdbar, UINT menuentryid, CString &str)
{
	CToolBarCtrl *ctrl= (CToolBarCtrl *)cmdbar;

	for (int i=0 ; i<3 ; i++)
	{
		UINT id, style;
		int image;
		cmdbar->GetButtonInfo(i, id, style, image);

		TBBUTTONINFO tbbi;
		tbbi.cbSize= sizeof(TBBUTTONINFO);
		tbbi.dwMask= TBIF_LPARAM;

		if (!ctrl->GetButtonInfo(id, &tbbi))
			continue;

		if (!tbbi.lParam)
			continue;

		CMenu *menu= CMenu::FromHandle((HMENU)tbbi.lParam);
		if (menu->GetMenuString(menuentryid, str, MF_BYCOMMAND)) {
			menu->CheckMenuRadioItem(id+1, id+49, menuentryid, MF_BYCOMMAND);
			return;
		}
	}
}

void CTstmodemDlg::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);
}


void CTstmodemDlg::OnBnClickedButtonConfig()
{
	CDialogChosePort dlg_ChosePort = new CDialogChosePort();
	dlg_ChosePort.SetModel(*m_port);
	dlg_ChosePort.DoModal();
	// TODO: Add your control notification handler code here
}

void CTstmodemDlg::OnBnClickedButtonOpenPort()
{	
	m_port->open();
}

void CTstmodemDlg::OnBnClickedButtonClosePort()
{
	m_port->close();
}

/* The macro define must have keep same with the define in wavemain.h */
#define WPDM_PRIVATE WM_USER+10
#define WPDM_PRIVATE_SETUP_PHONE_PATH       WPDM_PRIVATE+3 // enable the phone path from the telephone modem/hardware
#define WPDM_PRIVATE_DISABLE_PHONE_PATH     WPDM_PRIVATE+4 // disable the phone path from the telephone modem/hardware

void CTstmodemDlg::OnBnClickedCheckVoicePath()
{
	// TODO: Add your control notification handler code here
	if (m_EnableGsmVoice.GetCheck()==BST_CHECKED)
	{
		MMRESULT waveFuncRet = MMSYSERR_NOERROR;
		// Signal the audio driver that a voice call is starting
		/* Send message to wave for phone path setup */
		waveFuncRet = waveOutMessage(0, WPDM_PRIVATE_SETUP_PHONE_PATH, 0, 0);

		if (MMSYSERR_NOERROR != waveFuncRet)
		{
			debug("Unable to turn on GSM voice path.\r\n");
		}else 
		{
			debug("GSM voice path is on.\r\n");
		}
	}
	else
	{
		MMRESULT waveFuncRet = MMSYSERR_NOERROR;
		// Signal the audio driver that a voice call is starting
		/* Send message to wave for phone path setup */
		waveFuncRet = waveOutMessage(0, WPDM_PRIVATE_DISABLE_PHONE_PATH, 0, 0);

		if (MMSYSERR_NOERROR != waveFuncRet)
		{
			debug("Unable to turn off GSM voice path.\r\n");
		}else 
		{
			debug("GSM voice path is off.\r\n");
		}
	}
}