using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Text;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;

namespace CameraAppCE
{
    /**
     * This class converts the camera output file from Bitmap to JPEG
     */
    class ImageManipulator
    {
        public ImageManipulator(String imageLocation)
        {
            this.imageLocation = imageLocation;
        }
        private String imagePath;
        private String imageLocation;
        private const String CAMERA_FILE_PREFIX = "EXEDA_CAM_*.bmp";
        private bool getImagePath()
        {
            string[] files = Directory.GetFiles(imageLocation, CAMERA_FILE_PREFIX);
            if (files.Length == 0)
            {
                imagePath = null;
                return false;
            }
            imagePath = files[0];
            return true;

        }

        private void convertToBitmap()
        {
            if (imagePath == null)
                return;
            Bitmap bitmap = new Bitmap(imagePath);
            String jpegPath = imagePath.Replace(".bmp", ".jpg");
            bitmap.Save(jpegPath, ImageFormat.Jpeg);
            File.Delete(imagePath);
            imagePath = null;
        }
        
        public void convertFileFormat()
        {
            getImagePath();
            convertToBitmap();
        }
    }
}
